# Copyright (C) 1999 Jay Beale
# Licensed under the GNU General Public License

package Bastille::PatchDownload;

use Bastille::IO;
@ENV="";
$ENV{PATH}="";
$ENV{CDPATH}=".";
$ENV{BASH_ENV}="";

&PatchDownload;


#######################################################################
##                            Patch Download                         ##
#######################################################################

# Download specific RPMs from SPIRO-Linux's errata list
# We get the list of which ones to download from a Bastille/SANS web
# server, so as to avoid the question: "do we download all security
# patches indiscriminately, or do we put a static list in the script,
# for safety/predictability?

# TODO: Figure out _how_ to patch the kernel...
# TODO: Figure out how to secure this interaction...

sub PatchDownload {

   &ActionLog("# sub PatchDownload\n");
# We download the list of RPMs to upgrade from a Bastille/SANS site, 
# hardcoded as one of my web sites, until we get one, and then download
# only those RPMs for which the package was already installed.

print <<ENDPATCHNOW;

Patch Download:
This is intended to download security fixes from SPIRO-Linux.  If no patches
or updates are available, don't panic.  Your installation is fairly new,
and no security updates are available yet.

If you're using a phone modem to access the internet or you don't have 
networking working properly, please choose "No" to the next question.

                            WARNING: 
This script does not yet have a method for verifying that the patches it 
downloads are Authentic.  For instance, if the SPIRO-Linux web server we download 
from has been cracked, the attacker could place Trojan horses on the site.  We
include directions for getting these patches manually in the README.PATCH file.
You do need patches, though -- without patches, your risk of being hacked
is much higher.  You should only choose Yes here if you've weighed the risks.  

May we download and install the updated RPMs?  [Default:  No]
ENDPATCHNOW

   if (&GetYN eq "Y") {
      `./webget http://www.spiro-linux.com/errata/SECUREList`;
      &B_open(*BRHSRPMS,"SECUREList");
      while ($rpmline=<BRHSRPMS>) {
         if ($rpmline =~ /^ftp:\/\/.*\/(.*)-.*-.*\.i386\.rpm$/) {
            print "Downloading updated rpm $rpmline\n";
	    &ActionLog("# Downloading updated rpm $rpmline\n");
	    `./webget $rpmline`;
#            `/bin/rpm -F $rpmline`;
	    &ActionLog("rpm -F $rpmline\n");
         }
      }

      &B_close(*BRHSRPMS);
      `/bin/rpm -F *.rpm`;
      `/bin/rm SECUREList`;
   }
   else {
      print "Please install patches manually, following directions in README.PATCH!\n";
   }

}

1;

