# Copyright (C) 1999 Jay Beale
# Licensed under the GNU General Public License

package Bastille::PrepareToRun;

use Bastille::IO;
@ENV="";
$ENV{PATH}="";

# Clean up the environment so that we can run in Taint mode
# "D Johnson"'s idea with Don Wilder's fixes

@ENV="";
$ENV{PATH}="/sbin";
$ENV{CDPATH}=".";
$ENV{BASH_ENV}="";

$VERSION="1.00-1SPIRO";

# Banner
print <<BASTILLEBANNER;

============================================================================
                        Bastille Hardening Program
			         v$VERSION
				 
  This program should be run immediately after, and only immediately after,
  new installation of SPIRO.
  
  Please read the README file.
  
  This program is Copyright (C) 1999 Jay Beale and is licensed under the 
  GNU General Public License.  Read more about this in the file COPYING.
  
  This program has been modified to harden SPIRO-Linux to a more secure
  server/workstation.
============================================================================
BASTILLEBANNER

# Make sure we're in single user mode
open RUNLEVEL,"/sbin/runlevel |" or die "Couldn't determine runlevel to check single user mode!";
$levelline=<RUNLEVEL>;
close RUNLEVEL;
die "This script must be run in single user mode!\n\nType  init 1  at the unix prompt to switch to single user mode." unless ($levelline =~ /1 S/);

# Make sure at least one of the required files is here
if (! open(F,"<firewall_ipchains.txt") ) {
    die "It seems that some required files are missing. Please unpack the
Bastille distribution again and try again.\nTry \n   tar -xvpPf Bastille.tar\n";
}
close F;




# Start the logging up, using the subroutine from Bastille::IO

&StartLogging;

# Start networking, so we can later download rpms...

print "\n\nWe're starting networking...\n";
&ActionLog("# Starting networking\n");

`/etc/rc.d/init.d/pcmcia start`;
`/etc/rc.d/init.d/network start`;
&ActionLog("`/etc/rc.d/init.d/network start`\n");


1;

